////////////////
// APP.CPP: Sample MFC program demonstrating 
// unpredicatable order of static initializations.
//

#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

//////////////////
// Main application app, typical of MFC programs.
// Could also be TApplication-derived class in OWL.
//
class CMyApp : public CWinApp {
public:
	CMyApp();
	virtual BOOL InitInstance();
};

//////////////////
// Class whose constructor displays the address
// of the application object. It's only purpose is
// to depend on the intialization of theApp.
//
class CShowApp {
public:
	CShowApp();					// constructor
};

//////////////////
// CShowApp constructor displays address of the application
// object by calling AfxGetApp(), which works only if theApp
// has been initialized (constructed).
//
CShowApp::CShowApp()
{
	TRACE1("Testing: AfxGetApp() returns %p\n", AfxGetApp());
}

//////////////////
// Application constructor just displays a diagnostic message
//
CMyApp::CMyApp()
{
	TRACE1("Application object at %p now being constructed\n", this);
}

//////////////////
// Three static objects are instantiated here.  
// Within a module, objects are initialized in the order they appear,
// but among several modules the order is undefined.
//
CShowApp		show1;			// 1st static CShowApp object
CMyApp		theApp;			// the application
CShowApp		show2;			// 2nd static CShowApp object

BOOL CMyApp::InitInstance()
{
	return FALSE;				// return FALSE to quit app
}
